unit hiOneCopyProgram;

interface

uses Kol,Share,Debug,Windows;

type
  THIOneCopyProgram = class(TDebug)
   private
    mut:THandle;
    procedure SetID(ID:string);
    function Init_Mutex(mid:string):boolean;
    function mut_id(s:string):string;
   public
    _event_onCreate:THI_Event;

    constructor Create;
    destructor Destroy;override;
    property _prop_ID:string write SetID;
  end;

implementation


constructor THIOneCopyProgram.Create;
begin
  inherited Create;
end;

destructor THIOneCopyProgram.Destroy;
begin
  if Mut<>0 then CloseHandle(Mut);
end;

function THIOneCopyProgram.mut_id(s:string):string;
var
  f:integer;
begin
  result:=s;
  for f:=1 to length(s) do
    if result[f]='\' then result[f]:='_';
end;

function THIOneCopyProgram.Init_Mutex(mid:string):boolean;
begin
  Mut := CreateMutex(nil,false,pchar(mut_id(mid)));
  Result := not ((Mut = 0) or (GetLastError = ERROR_ALREADY_EXISTS));
end;

procedure THIOneCopyProgram.SetID;
begin
  if not init_mutex(ID) then begin
    Applet.Close;
  end;
end;

end.
